# -*- coding: utf8 -*-
from __future__ import unicode_literals

from driverng.drivers.bcsxp_spec import Driver as DriverBcsXp


class Driver(DriverBcsXp):
    SPEC = {"code": "atellica_coag360_astm", "label": "Atellica COAG 360 ASTM"}

    def encode_worklist(self, worklist, context):
        message = self.create()
        for patient in worklist.get_astm_worklist(
            unique_together=["action", "priority", "rerun"],
            action={"del": worklist.IGNORE, worklist.ELSE: ""},
            priority={"A": "S", "S": "S", worklist.ELSE: "R"},
        ):
            seg_p = message.patients.add(
                patient_id=patient.patient_id,
                last_name=patient.last_name,
                first_name=patient.first_name,
                middle_name="",
                birthdate=patient.birthdate,
                sex=patient.sex,
            )

            for sample, action, priority, rerun in patient.samples:
                physician = [p for p in patient.physicians if p.type == "prescriber"]
                if rerun:
                    action = "A"
                seg_o = seg_p.orders.add(
                    sample_id2=sample.sample_id,
                    priority=priority,
                    action_code=action,
                    physician=physician[0].code if physician else "",
                    report_type="Q",
                )
                for order in sample.orders:
                    t = seg_o.assay.add()
                    t.code = order["code"]

        if message.patients:
            return message
        elif context["query"]:
            for seg_q in context["query"].queries:
                seg_noreq = message.queries.add()
                seg_noreq.sample_id = seg_q.sample_id
                seg_noreq.status_code = "X"
            return message
